//    .
unit Transformations;
uses Types, Tuples, Containers;
const
  Eps = 1E-5;

//     x   selector(x).
function Select(collection: IntArray; selector: IntSelector1): IntArray;
var
  i: int;

begin
  Result := IntArray.Create();
  for i := 1 to collection.Count do
    Result.Add(selector(collection[i]));
end;

//     x   selector(x).
function Select(collection: RealArray; selector: RealSelector1): RealArray;
var
  i: int;

begin
  Result := RealArray.Create();
  for i := 1 to collection.Count do
    Result.Add(selector(collection[i]));
end;

//     x   selector(x).
function Select(collection: StringArray; selector: StringSelector1): StringArray;
var
  i: int;

begin
  Result := StringArray.Create();
  for i := 1 to collection.Count do
    Result.Add(selector(collection[i]));
end;


//     x   selector(x)    x.
function Select(collection: IntArray; selector: IntSelector2): IntArray;
var
  i: int;

begin
  Result := IntArray.Create();
  for i := 1 to collection.Count do
    Result.Add(selector(i, collection[i]));
end;

//     x   selector(x)    x.
function Select(collection: RealArray; selector: RealSelector2): RealArray;
var
  i: int;

begin
  Result := RealArray.Create();
  for i := 1 to collection.Count do
    Result.Add(selector(i, collection[i]));
end;

//     x   selector(x)    x.
function Select(collection: StringArray; selector: StringSelector2): StringArray;
var
  i: int;

begin
  Result := StringArray.Create();
  for i := 1 to collection.Count do
    Result.Add(selector(i, collection[i]));
end;


//        .
function All(collection: IntArray; p: IntPredicate1): bool;
var
  i: int;

begin
  Result := true;
  for i := 1 to collection.Count do
  begin
    if not p(collection[i]) then
    begin
      Result := false;
      exit;
    end;
    Inc(i);
  end;
end;

//        .
function All(collection: RealArray; p: RealPredicate1): bool;
var
  i: int;

begin
  Result := true;
  for i := 1 to collection.Count do
  begin
    if not p(collection[i]) then
    begin
      Result := false;
      exit;
    end;
    Inc(i);
  end;
end;

//        .
function All(collection: StringArray; p: StringPredicate1): bool;
var
  i: int;

begin
  Result := true;
  for i := 1 to collection.Count do
  begin
    if not p(collection[i]) then
    begin
      Result := false;
      exit;
    end;
    Inc(i);
  end;
end;

//           .
function All(collection: IntArray; p: IntPredicate2): bool;
var
  i: int;

begin
  Result := true;
  for i := 1 to collection.Count do
  begin
    if not p(i, collection[i]) then
    begin
      Result := false;
      exit;
    end;
    Inc(i);
  end;
end;

//           .
function All(collection: RealArray; p: RealPredicate2): bool;
var
  i: int;

begin
  Result := true;
  for i := 1 to collection.Count do
  begin
    if not p(i, collection[i]) then
    begin
      Result := false;
      exit;
    end;
    Inc(i);
  end;
end;

//           .
function All(collection: StringArray; p: StringPredicate2): bool;
var
  i: int;

begin
  Result := true;
  for i := 1 to collection.Count do
  begin
    if not p(i, collection[i]) then
    begin
      Result := false;
      exit;
    end;
    Inc(i);
  end;
end;


//          .
function Any(collection: IntArray; p: IntPredicate1): bool;
var
  i: int;

begin
  Result := false;
  for i := 1 to collection.Count do
  begin
    if not p(collection[i]) then
    begin
      Result := true;
      exit;
    end;
    Inc(i);
  end;
end;

//          .
function Any(collection: RealArray; p: RealPredicate1): bool;
var
  i: int;

begin
  Result := false;
  for i := 1 to collection.Count do
  begin
    if not p(collection[i]) then
    begin
      Result := true;
      exit;
    end;
    Inc(i);
  end;
end;

//          .
function Any(collection: StringArray; p: StringPredicate1): bool;
var
  i: int;

begin
  Result := false;
  for i := 1 to collection.Count do
  begin
    if not p(collection[i]) then
    begin
      Result := true;
      exit;
    end;
    Inc(i);
  end;
end;

//          .
function Any(collection: IntArray; p: IntPredicate2): bool;
var
  i: int;

begin
  Result := false;
  for i := 1 to collection.Count do
  begin
    if not p(i, collection[i]) then
    begin
      Result := true;
      exit;
    end;
    Inc(i);
  end;
end;

//          .
function Any(collection: RealArray; p: RealPredicate2): bool;
var
  i: int;

begin
  Result := false;
  for i := 1 to collection.Count do
  begin
    if not p(i, collection[i]) then
    begin
      Result := true;
      exit;
    end;
    Inc(i);
  end;
end;

//          .
function Any(collection: StringArray; p: StringPredicate2): bool;
var
  i: int;

begin
  Result := false;
  for i := 1 to collection.Count do
  begin
    if not p(i, collection[i]) then
    begin
      Result := true;
      exit;
    end;
    Inc(i);
  end;
end;


//  ,      ,   .
function Where(collection: IntArray; p: IntPredicate1): IntArray;
var
  i: int;

begin
  i := 1;
  Result := IntArray.Create();

  for i := 1 to collection.Count do
    if p(collection[i]) then
      Result.Add(collection[i]);
end;

//  ,      ,   .
function Where(collection: RealArray; p: RealPredicate1): RealArray;
var
  i: int;

begin
  i := 1;
  Result := RealArray.Create();

  for i := 1 to collection.Count do
    if p(collection[i]) then
      Result.Add(collection[i]);
end;

//  ,      ,   .
function Where(collection: StringArray; p: StringPredicate1): StringArray;
var
  i: int;

begin
  i := 1;
  Result := StringArray.Create();

  for i := 1 to collection.Count do
    if p(collection[i]) then
      Result.Add(collection[i]);
end;

//  ,      ,   .
function Where(collection: IntArray; p: IntPredicate2): IntArray;
var
  i: int;

begin
  i := 1;
  Result := IntArray.Create();

  for i := 1 to collection.Count do
    if p(i, collection[i]) then
      Result.Add(collection[i]);
end;

//  ,      ,   .
function Where(collection: RealArray; p: RealPredicate2): RealArray;
var
  i: int;

begin
  i := 1;
  Result := RealArray.Create();

  for i := 1 to collection.Count do
    if p(i, collection[i]) then
      Result.Add(collection[i]);
end;

//  ,      ,   .
function Where(collection: StringArray; p: StringPredicate2): StringArray;
var
  i: int;

begin
  i := 1;
  Result := StringArray.Create();

  for i := 1 to collection.Count do
    if p(i, collection[i]) then
      Result.Add(collection[i]);
end;


function IsPositive(x: int): bool;
begin
  Result := x > 0;
end;

function IsNegative(x: int): bool;
begin
  Result := x < 0;
end;

function IsZero(x: int): bool;
begin
  Result := x = 0;
end;

function IsPositive(x: real): bool;
begin
  Result := x > Eps;
end;

function IsNegative(x: real): bool;
begin
  Result := x < -Eps;
end;

function IsZero(x: real): bool;
begin
  Result := Abs(x) < Eps;
end;

function IsWhitespace(x: string): bool;
begin
  Result := x = ' ';
end;


//      .
function IntToStr(collection: IntArray): StringArray;
var
  i: int;

begin
  Result := StringArray.Create();
  for i := 1 to collection.Count do
    Result.Add(IntToStr(collection[i]));
end;

//      .
function FloatToStr(collection: IntArray): StringArray;
var
  i: int;

begin
  Result := StringArray.Create();
  for i := 1 to collection.Count do
    Result.Add(FloatToStr(collection[i]));
end;

//      .
function StrToInt(collection: StringArray): IntArray;
var
  i: int;

begin
  Result := IntArray.Create();
  for i := 1 to collection.Count do
    Result.Add(StrToInt(collection[i]));
end;

//      .
function StrToFloat(collection: StringArray): RealArray;
var
  i: int;

begin
  Result := RealArray.Create();
  for i := 1 to collection.Count do
    Result.Add(StrToFloat(collection[i]));
end;


//        .
function ToWords(s: string): StringArray;
var
  i: int;
  s1: string;
  
begin
  i := 1;
  
  Result := StringArray.Create();
  while i <= Length(s) do
  begin
    s1 := '';
    while (i <= Length(s)) and (s[i] = ' ') do
      Inc(i);
    while (i <= Length(s)) and (s[i] <> ' ') do
    begin
      s1 := s1 + s[i];
      Inc(i);
    end;
    if s1 <> '' then
      Result.Add(s1);
  end;
end;

//     .
function ToIntegers(s: string): IntArray;
begin
  Result := StrToInt(ToWords(s));
end;

//     .
function ToReals(s: string): RealArray;
begin
  Result := StrToFloat(ToWords(s));
end;
end.