//  .
unit Tuples;
uses Types;

type
  IntTuple2 = class
  protected
    _item1, _item2: int;

    function getItem(index: int): int;
    begin
      case index of
        0: Result := _item1;
        1: Result := _item2;
        else raise ERangeError.Create();
      end;
    end;
    
    procedure setItem(index, value: int);
    begin
      raise EInvalidOp.Create();
    end;
    
  public
    property Item[index: int]: int read getItem write setItem;
    property Item1: int read _item1;
    property Item2: int read _item2;

    constructor Create(item1, item2: int);
    begin
      _item1 := item1;
      _item2 := item2;
    end;
  end;
  
  IntTuple3 = class(IntTuple2)
  protected
    _item3: int;

    function getItem(index: int): int;
    begin
      case index of
        0: Result := _item1;
        1: Result := _item2;
        2: Result := _item3;
        else raise ERangeError.Create();
      end;
    end;
    
  public
    property Item3: int read _item3;

    constructor Create(item1, item2, item3: int);
    begin
      inherited Create(item1, item2);
      _item3 := item3;
    end;
  end;
  
  IntTuple4 = class(IntTuple3)
  protected
    _item4: int;

    function getItem(index: int): int;
    begin
      case index of
        0: Result := _item1;
        1: Result := _item2;
        2: Result := _item3;
        3: Result := _item4;
        else raise ERangeError.Create();
      end;
    end;
    
  public
    property Item4: int read _item4;

    constructor Create(item1, item2, item3, item4: int);
    begin
      inherited Create(item1, item2, item3);
      _item4 := item4;
    end;
  end;
  
  IntTuple5 = class(IntTuple4)
  protected
    _item5: int;

    function getItem(index: int): int;
    begin
      case index of
        0: Result := _item1;
        1: Result := _item2;
        2: Result := _item3;
        3: Result := _item4;
        4: Result := _item5;
        else raise ERangeError.Create();
      end;
    end;

  public
    property Item5: int read _item5;

    constructor Create(item1, item2, item3, item4, item5: int);
    begin
      inherited Create(item1, item2, item3, item4);
      _item5 := item5;
    end;
  end;
  
  IntTuple6 = class(IntTuple5)
  protected
    _item6: int;

    function getItem(index: int): int;
    begin
      case index of
        0: Result := _item1;
        1: Result := _item2;
        2: Result := _item3;
        3: Result := _item4;
        4: Result := _item5;
        5: Result := _item6;
        else raise ERangeError.Create();
      end;
    end;

  public
    property Item6: int read _item6;

    constructor Create(item1, item2, item3, item4, item5, item6: int);
    begin
      inherited Create(item1, item2, item3, item4, item5);
      _item6 := item6;
    end;
  end;
  
  IntTuple7 = class(IntTuple6)
  protected
    _item7: int;

    function getItem(index: int): int;
    begin
      case index of
        0: Result := _item1;
        1: Result := _item2;
        2: Result := _item3;
        3: Result := _item4;
        4: Result := _item5;
        5: Result := _item6;
        6: Result := _item7;
        else raise ERangeError.Create();
      end;
    end;

  public
    property Item7: int read _item7;

    constructor Create(item1, item2, item3, item4, item5, item6, item7: int);
    begin
      inherited Create(item1, item2, item3, item4, item5, item6);
      _item7 := item7;
    end;
  end;
  
type
  RealTuple2 = class
  protected
    _item1, _item2: real;

    function getItem(index: int): real;
    begin
      case index of
        0: Result := _item1;
        1: Result := _item2;
        else raise ERangeError.Create();
      end;
    end;
    
    procedure setItem(index: int; value: real);
    begin
      raise EInvalidOp.Create();
    end;
    
  public
    property Item[index: int]: real read getItem write setItem;
    property Item1: real read _item1;
    property Item2: real read _item2;

    constructor Create(item1, item2: real);
    begin
      _item1 := item1;
      _item2 := item2;
    end;
  end;

  RealTuple3 = class(RealTuple2)
  protected
    _item3: real;

    function getItem(index: int): real;
    begin
      case index of
        0: Result := _item1;
        1: Result := _item2;
        2: Result := _item3;
        else raise ERangeError.Create();
      end;
    end;

  public
    property Item3: real read _item3;

    constructor Create(item1, item2, item3: real);
    begin
      inherited Create(item1, item2);
      _item3 := item3;
    end;
  end;

  RealTuple4 = class(RealTuple3)
  protected
    _item4: real;

    function getItem(index: int): real;
    begin
      case index of
        0: Result := _item1;
        1: Result := _item2;
        2: Result := _item3;
        3: Result := _item4;
        else raise ERangeError.Create();
      end;
    end;

  public
    property Item4: real read _item4;

    constructor Create(item1, item2, item3, item4: real);
    begin
      inherited Create(item1, item2, item3);
      _item4 := item4;
    end;
  end;

  RealTuple5 = class(RealTuple4)
  protected
    _item5: real;

    function getItem(index: int): real;
    begin
      case index of
        0: Result := _item1;
        1: Result := _item2;
        2: Result := _item3;
        3: Result := _item4;
        4: Result := _item5;
        else raise ERangeError.Create();
      end;
    end;

  public
    property Item5: real read _item5;

    constructor Create(item1, item2, item3, item4, item5: real);
    begin
      inherited Create(item1, item2, item3, item4);
      _item5 := item5;
    end;
  end;

  RealTuple6 = class(RealTuple5)
  protected
    _item6: real;

    function getItem(index: int): real;
    begin
      case index of
        0: Result := _item1;
        1: Result := _item2;
        2: Result := _item3;
        3: Result := _item4;
        4: Result := _item5;
        5: Result := _item6;
        else raise ERangeError.Create();
      end;
    end;

  public
    property Item6: real read _item6;

    constructor Create(item1, item2, item3, item4, item5, item6: real);
    begin
      inherited Create(item1, item2, item3, item4, item5);
      _item6 := item6;
    end;
  end;

  RealTuple7 = class(RealTuple6)
  protected
    _item7: real;

    function getItem(index: int): real;
    begin
      case index of
        0: Result := _item1;
        1: Result := _item2;
        2: Result := _item3;
        3: Result := _item4;
        4: Result := _item5;
        5: Result := _item6;
        6: Result := _item7;
        else raise ERangeError.Create();
      end;
    end;

  public
    property Item7: real read _item7;

    constructor Create(item1, item2, item3, item4, item5, item6, item7: real);
    begin
      inherited Create(item1, item2, item3, item4, item5, item6);
      _item7 := item7;
    end;
  end;
  
type
  CharTuple2 = class
  protected
    _item1, _item2: char;

    function getItem(index: int): char;
    begin
      case index of
        0: Result := _item1;
        1: Result := _item2;
        else raise ERangeError.Create();
      end;
    end;

    procedure setItem(index: int; value: char);
    begin
      raise EInvalidOp.Create();
    end;

  public
    property Item[index: int]: char read getItem write setItem;
    property Item1: char read _item1;
    property Item2: char read _item2;

    constructor Create(item1, item2: char);
    begin
      _item1 := item1;
      _item2 := item2;
    end;
  end;

  CharTuple3 = class(CharTuple2)
  protected
    _item3: char;

    function getItem(index: int): char;
    begin
      case index of
        0: Result := _item1;
        1: Result := _item2;
        2: Result := _item3;
        else raise ERangeError.Create();
      end;
    end;

  public
    property Item3: char read _item3;

    constructor Create(item1, item2, item3: char);
    begin
      inherited Create(item1, item2);
      _item3 := item3;
    end;
  end;

  CharTuple4 = class(CharTuple3)
  protected
    _item4: char;

    function getItem(index: int): char;
    begin
      case index of
        0: Result := _item1;
        1: Result := _item2;
        2: Result := _item3;
        3: Result := _item4;
        else raise ERangeError.Create();
      end;
    end;

  public
    property Item4: char read _item4;

    constructor Create(item1, item2, item3, item4: char);
    begin
      inherited Create(item1, item2, item3);
      _item4 := item4;
    end;
  end;

  CharTuple5 = class(CharTuple4)
  protected
    _item5: char;

    function getItem(index: int): char;
    begin
      case index of
        0: Result := _item1;
        1: Result := _item2;
        2: Result := _item3;
        3: Result := _item4;
        4: Result := _item5;
        else raise ERangeError.Create();
      end;
    end;

  public
    property Item5: char read _item5;

    constructor Create(item1, item2, item3, item4, item5: char);
    begin
      inherited Create(item1, item2, item3, item4);
      _item5 := item5;
    end;
  end;

  CharTuple6 = class(CharTuple5)
  protected
    _item6: char;

    function getItem(index: int): char;
    begin
      case index of
        0: Result := _item1;
        1: Result := _item2;
        2: Result := _item3;
        3: Result := _item4;
        4: Result := _item5;
        5: Result := _item6;
        else raise ERangeError.Create();
      end;
    end;

  public
    property Item6: char read _item6;

    constructor Create(item1, item2, item3, item4, item5, item6: char);
    begin
      inherited Create(item1, item2, item3, item4, item5);
      _item6 := item6;
    end;
  end;

  CharTuple7 = class(CharTuple6)
  protected
    _item7: char;

    function getItem(index: int): char;
    begin
      case index of
        0: Result := _item1;
        1: Result := _item2;
        2: Result := _item3;
        3: Result := _item4;
        4: Result := _item5;
        5: Result := _item6;
        6: Result := _item7;
        else raise ERangeError.Create();
      end;
    end;

  public
    property Item7: char read _item7;

    constructor Create(item1, item2, item3, item4, item5, item6, item7: char);
    begin
      inherited Create(item1, item2, item3, item4, item5, item6);
      _item7 := item7;
    end;
  end;
  
type
  StringTuple2 = class
  protected
    _item1, _item2: string;

    function getItem(index: int): string;
    begin
      case index of
        0: Result := _item1;
        1: Result := _item2;
        else raise ERangeError.Create();
      end;
    end;

    procedure setItem(index: int; value: string);
    begin
      raise EInvalidOp.Create();
    end;

  public
    property Item[index: int]: string read getItem write setItem;
    property Item1: string read _item1;
    property Item2: string read _item2;

    constructor Create(item1, item2: string);
    begin
      _item1 := item1;
      _item2 := item2;
    end;
  end;

  StringTuple3 = class(StringTuple2)
  protected
    _item3: string;

    function getItem(index: int): string;
    begin
      case index of
        0: Result := _item1;
        1: Result := _item2;
        2: Result := _item3;
        else raise ERangeError.Create();
      end;
    end;

  public
    property Item3: string read _item3;

    constructor Create(item1, item2, item3: string);
    begin
      inherited Create(item1, item2);
      _item3 := item3;
    end;
  end;

  StringTuple4 = class(StringTuple3)
  protected
    _item4: string;

    function getItem(index: int): string;
    begin
      case index of
        0: Result := _item1;
        1: Result := _item2;
        2: Result := _item3;
        3: Result := _item4;
        else raise ERangeError.Create();
      end;
    end;

  public
    property Item4: string read _item4;

    constructor Create(item1, item2, item3, item4: string);
    begin
      inherited Create(item1, item2, item3);
      _item4 := item4;
    end;
  end;

  StringTuple5 = class(StringTuple4)
  protected
    _item5: string;

    function getItem(index: int): string;
    begin
      case index of
        0: Result := _item1;
        1: Result := _item2;
        2: Result := _item3;
        3: Result := _item4;
        4: Result := _item5;
        else raise ERangeError.Create();
      end;
    end;

  public
    property Item5: string read _item5;

    constructor Create(item1, item2, item3, item4, item5: string);
    begin
      inherited Create(item1, item2, item3, item4);
      _item5 := item5;
    end;
  end;

  StringTuple6 = class(StringTuple5)
  protected
    _item6: string;

    function getItem(index: int): string;
    begin
      case index of
        0: Result := _item1;
        1: Result := _item2;
        2: Result := _item3;
        3: Result := _item4;
        4: Result := _item5;
        5: Result := _item6;
        else raise ERangeError.Create();
      end;
    end;

  public
    property Item6: string read _item6;

    constructor Create(item1, item2, item3, item4, item5, item6: string);
    begin
      inherited Create(item1, item2, item3, item4, item5);
      _item6 := item6;
    end;
  end;

  StringTuple7 = class(StringTuple6)
  protected
    _item7: string;

    function getItem(index: int): string;
    begin
      case index of
        0: Result := _item1;
        1: Result := _item2;
        2: Result := _item3;
        3: Result := _item4;
        4: Result := _item5;
        5: Result := _item6;
        6: Result := _item7;
        else raise ERangeError.Create();
      end;
    end;

  public
    property Item7: string read _item7;

    constructor Create(item1, item2, item3, item4, item5, item6, item7: string);
    begin
      inherited Create(item1, item2, item3, item4, item5, item6);
      _item7 := item7;
    end;
  end;
  
type
  Tuple2 = class
  protected
    _item1, _item2: object;

    function getItem(index: int): object;
    begin
      case index of
        0: Result := _item1;
        1: Result := _item2;
        else raise ERangeError.Create();
      end;
    end;

    procedure setItem(index: int; value: object);
    begin
      raise EInvalidOp.Create();
    end;

  public
    property Item[index: int]: object read getItem write setItem;
    property Item1: object read _item1;
    property Item2: object read _item2;

    constructor Create(item1, item2: object);
    begin
      _item1 := item1;
      _item2 := item2;
    end;
  end;

  Tuple3 = class(Tuple2)
  protected
    _item3: object;

    function getItem(index: int): object;
    begin
      case index of
        0: Result := _item1;
        1: Result := _item2;
        2: Result := _item3;
        else raise ERangeError.Create();
      end;
    end;

  public
    property Item3: object read _item3;

    constructor Create(item1, item2, item3: object);
    begin
      inherited Create(item1, item2);
      _item3 := item3;
    end;
  end;

  Tuple4 = class(Tuple3)
  protected
    _item4: object;

    function getItem(index: int): object;
    begin
      case index of
        0: Result := _item1;
        1: Result := _item2;
        2: Result := _item3;
        3: Result := _item4;
        else raise ERangeError.Create();
      end;
    end;

  public
    property Item4: object read _item4;

    constructor Create(item1, item2, item3, item4: object);
    begin
      inherited Create(item1, item2, item3);
      _item4 := item4;
    end;
  end;

  Tuple5 = class(Tuple4)
  protected
    _item5: object;

    function getItem(index: int): object;
    begin
      case index of
        0: Result := _item1;
        1: Result := _item2;
        2: Result := _item3;
        3: Result := _item4;
        4: Result := _item5;
        else raise ERangeError.Create();
      end;
    end;

  public
    property Item5: object read _item5;

    constructor Create(item1, item2, item3, item4, item5: object);
    begin
      inherited Create(item1, item2, item3, item4);
      _item5 := item5;
    end;
  end;

  Tuple6 = class(Tuple5)
  protected
    _item6: object;

    function getItem(index: int): object;
    begin
      case index of
        0: Result := _item1;
        1: Result := _item2;
        2: Result := _item3;
        3: Result := _item4;
        4: Result := _item5;
        5: Result := _item6;
        else raise ERangeError.Create();
      end;
    end;

  public
    property Item6: object read _item6;

    constructor Create(item1, item2, item3, item4, item5, item6: object);
    begin
      inherited Create(item1, item2, item3, item4, item5);
      _item6 := item6;
    end;
  end;

  Tuple7 = class(Tuple6)
  protected
    _item7: object;

    function getItem(index: int): object;
    begin
      case index of
        0: Result := _item1;
        1: Result := _item2;
        2: Result := _item3;
        3: Result := _item4;
        4: Result := _item5;
        5: Result := _item6;
        6: Result := _item7;
        else raise ERangeError.Create();
      end;
    end;

  public
    property Item7: object read _item7;

    constructor Create(item1, item2, item3, item4, item5, item6, item7: object);
    begin
      inherited Create(item1, item2, item3, item4, item5, item6);
      _item7 := item7;
    end;
  end;

  
function IntTpl2(item1, item2: int): IntTuple2; // <<<
begin
  Result := IntTuple2.Create(item1, item2);
end;

function IntTpl3(item1, item2, item3: int): IntTuple3;
begin
  Result := IntTuple3.Create(item1, item2, item3);
end;

function IntTpl4(item1, item2, item3, item4: int): IntTuple4;
begin
  Result := IntTuple4.Create(item1, item2, item3, item4);
end;

function IntTpl5(item1, item2, item3, item4, item5: int): IntTuple5;
begin
  Result := IntTuple5.Create(item1, item2, item3, item4, item5);
end;

function IntTpl6(item1, item2, item3, item4, item5, item6: int): IntTuple6;
begin
  Result := IntTuple6.Create(item1, item2, item3, item4, item5, item6);
end;

function IntTpl7(item1, item2, item3, item4, item5, item6, item7: int): IntTuple7;
begin
  Result := IntTuple7.Create(item1, item2, item3, item4, item5, item6, item7);
end;


function RealTpl2(item1, item2: real): RealTuple2; // <<<
begin
  Result := RealTuple2.Create(item1, item2);
end;

function RealTpl3(item1, item2, item3: real): RealTuple3;
begin
  Result := RealTuple3.Create(item1, item2, item3);
end;

function RealTpl4(item1, item2, item3, item4: real): RealTuple4;
begin
  Result := RealTuple4.Create(item1, item2, item3, item4);
end;

function RealTpl5(item1, item2, item3, item4, item5: real): RealTuple5;
begin
  Result := RealTuple5.Create(item1, item2, item3, item4, item5);
end;

function RealTpl6(item1, item2, item3, item4, item5, item6: real): RealTuple6;
begin
  Result := RealTuple6.Create(item1, item2, item3, item4, item5, item6);
end;

function RealTpl7(item1, item2, item3, item4, item5, item6, item7: real): RealTuple7;
begin
  Result := RealTuple7.Create(item1, item2, item3, item4, item5, item6, item7);
end;


function CharTpl2(item1, item2: char): CharTuple2; // <<<
begin
  Result := CharTuple2.Create(item1, item2);
end;

function CharTpl3(item1, item2, item3: char): CharTuple3;
begin
  Result := CharTuple3.Create(item1, item2, item3);
end;

function CharTpl4(item1, item2, item3, item4: char): CharTuple4;
begin
  Result := CharTuple4.Create(item1, item2, item3, item4);
end;

function CharTpl5(item1, item2, item3, item4, item5: char): CharTuple5;
begin
  Result := CharTuple5.Create(item1, item2, item3, item4, item5);
end;

function CharTpl6(item1, item2, item3, item4, item5, item6: char): CharTuple6;
begin
  Result := CharTuple6.Create(item1, item2, item3, item4, item5, item6);
end;

function CharTpl7(item1, item2, item3, item4, item5, item6, item7: char): CharTuple7;
begin
  Result := CharTuple7.Create(item1, item2, item3, item4, item5, item6, item7);
end;


function StringTpl2(item1, item2: string): StringTuple2; // <<<
begin
  Result := StringTuple2.Create(item1, item2);
end;

function StringTpl3(item1, item2, item3: string): StringTuple3;
begin
  Result := StringTuple3.Create(item1, item2, item3);
end;

function StringTpl4(item1, item2, item3, item4: string): StringTuple4;
begin
  Result := StringTuple4.Create(item1, item2, item3, item4);
end;

function StringTpl5(item1, item2, item3, item4, item5: string): StringTuple5;
begin
  Result := StringTuple5.Create(item1, item2, item3, item4, item5);
end;

function StringTpl6(item1, item2, item3, item4, item5, item6: string): StringTuple6;
begin
  Result := StringTuple6.Create(item1, item2, item3, item4, item5, item6);
end;

function StringTpl7(item1, item2, item3, item4, item5, item6, item7: string): StringTuple7;
begin
  Result := StringTuple7.Create(item1, item2, item3, item4, item5, item6, item7);
end;


function Tpl2(item1, item2: object): Tuple2; // <<<
begin
  Result := Tuple2.Create(item1, item2);
end;

function Tpl3(item1, item2, item3: object): Tuple3;
begin
  Result := Tuple3.Create(item1, item2, item3);
end;

function Tpl4(item1, item2, item3, item4: object): Tuple4;
begin
  Result := Tuple4.Create(item1, item2, item3, item4);
end;

function Tpl5(item1, item2, item3, item4, item5: object): Tuple5;
begin
  Result := Tuple5.Create(item1, item2, item3, item4, item5);
end;

function Tpl6(item1, item2, item3, item4, item5, item6: object): Tuple6;
begin
  Result := Tuple6.Create(item1, item2, item3, item4, item5, item6);
end;

function Tpl7(item1, item2, item3, item4, item5, item6, item7: object): Tuple7;
begin
  Result := Tuple7.Create(item1, item2, item3, item4, item5, item6, item7);
end;
end.