//   .
unit Types;
type
  int = integer;
  bool = boolean;

type
  PInt = ^int;
  PReal = ^real;
  PChar = ^char;
  PComplex = ^complex;

type
  NumbersEnum = 0..9;

type
  Action = procedure;

type
  IntAction1 = procedure(x1: int);
  IntAction2 = procedure(x1, x2: int);
  IntAction3 = procedure(x1, x2, x3: int);
  IntAction4 = procedure(x1, x2, x3, x4: int);
  IntAction5 = procedure(x1, x2, x3, x4, x5: int);
  IntAction6 = procedure(x1, x2, x3, x4, x5, x6: int);
  IntAction7 = procedure(x1, x2, x3, x4, x5, x6, x7: int);

type
  RealAction1 = procedure(x1: real);
  RealAction2 = procedure(x1, x2: real);
  RealAction3 = procedure(x1, x2, x3: real);
  RealAction4 = procedure(x1, x2, x3, x4: real);
  RealAction5 = procedure(x1, x2, x3, x4, x5: real);
  RealAction6 = procedure(x1, x2, x3, x4, x5, x6: real);
  RealAction7 = procedure(x1, x2, x3, x4, x5, x6, x7: real);

type
  CharAction1 = procedure(x1: char);
  CharAction2 = procedure(x1, x2: char);
  CharAction3 = procedure(x1, x2, x3: char);
  CharAction4 = procedure(x1, x2, x3, x4: char);
  CharAction5 = procedure(x1, x2, x3, x4, x5: char);
  CharAction6 = procedure(x1, x2, x3, x4, x5, x6: char);
  CharAction7 = procedure(x1, x2, x3, x4, x5, x6, x7: char);

type
  StringAction1 = procedure(x1: string);
  StringAction2 = procedure(x1, x2: string);
  StringAction3 = procedure(x1, x2, x3: string);
  StringAction4 = procedure(x1, x2, x3, x4: string);
  StringAction5 = procedure(x1, x2, x3, x4, x5: string);
  StringAction6 = procedure(x1, x2, x3, x4, x5, x6: string);
  StringAction7 = procedure(x1, x2, x3, x4, x5, x6, x7: string);

type
  IntFunc = function: int;
  RealFunc = function: real;
  CharFunc = function: char;
  StringFunc = function: string;

type
  IntFunc1 = function(x1: int): int;
  IntFunc2 = function(x1, x2: int): int;
  IntFunc3 = function(x1, x2, x3: int): int;
  IntFunc4 = function(x1, x2, x3, x4: int): int;
  IntFunc5 = function(x1, x2, x3, x4, x5: int): int;
  IntFunc6 = function(x1, x2, x3, x4, x5, x6: int): int;
  IntFunc7 = function(x1, x2, x3, x4, x5, x6, x7: int): int;

type
  RealFunc1 = function(x1: real): real;
  RealFunc2 = function(x1, x2: real): real;
  RealFunc3 = function(x1, x2, x3: real): real;
  RealFunc4 = function(x1, x2, x3, x4: real): real;
  RealFunc5 = function(x1, x2, x3, x4, x5: real): real;
  RealFunc6 = function(x1, x2, x3, x4, x5, x6: real): real;
  RealFunc7 = function(x1, x2, x3, x4, x5, x6, x7: real): real;

type
  CharFunc1 = function(x1: char): char;
  CharFunc2 = function(x1, x2: char): char;
  CharFunc3 = function(x1, x2, x3: char): char;
  CharFunc4 = function(x1, x2, x3, x4: char): char;
  CharFunc5 = function(x1, x2, x3, x4, x5: char): char;
  CharFunc6 = function(x1, x2, x3, x4, x5, x6: char): char;
  CharFunc7 = function(x1, x2, x3, x4, x5, x6, x7: char): char;

type
  StringFunc1 = function(x1: string): string;
  StringFunc2 = function(x1, x2: string): string;
  StringFunc3 = function(x1, x2, x3: string): string;
  StringFunc4 = function(x1, x2, x3, x4: string): string;
  StringFunc5 = function(x1, x2, x3, x4, x5: string): string;
  StringFunc6 = function(x1, x2, x3, x4, x5, x6: string): string;
  StringFunc7 = function(x1, x2, x3, x4, x5, x6, x7: string): string;

type
  IntSelector1 = IntFunc1;
  RealSelector1 = RealFunc1;
  CharSelector1 = CharFunc1;
  StringSelector1 = StringFunc1;
  
  IntSelector2 = IntFunc2;
  RealSelector2 = function(index: int; x1: real): real;
  StringSelector2 = function(index: int; x1: string): string;

type
  IntPredicate1 = function(x1: int): bool;
  RealPredicate1 = function(x1: real): bool;
  StringPredicate1 = function(x1: string): bool;

  IntPredicate2 = function(index, x1: int): bool;
  RealPredicate2 = function(index: int; x1: real): bool;
  StringPredicate2 = function(index: int; x1: string): bool;
  
type
  PIntNodeRec = ^IntNodeRec;
  IntNodeRec = record
     Value: int;
     Next: PIntNodeRec;
  end;
  
  PRealNodeRec = ^RealNodeRec;
  RealNodeRec = record
     Value: real;
     Next: PRealNodeRec;
  end;
  
  PCharNodeRec = ^CharNodeRec;
  CharNodeRec = record
     Value: char;
     Next: PCharNodeRec;
  end;
  
type
  IntNode = class
  private
    _value: int;
    _next: IntNode;
    
  public
    property Value: int read _value write _value;
    property Next: IntNode read _next write _next;
    
    constructor Create(value: int; next: IntNode);
    begin
      _value := value;
      _next := next;
    end;
    
    constructor Create(value: int);
    begin
      Create(value, nil);
    end;
  end;
  
  RealNode = class
  private
    _value: real;
    _next: RealNode;

  public
    property Value: real read _value write _value;
    property Next: RealNode read _next write _next;

    constructor Create(value: real; next: RealNode);
    begin
      _value := value;
      _next := next;
    end;

    constructor Create(value: real);
    begin
      Create(value, nil);
    end;
  end;
  
  CharNode = class
  private
    _value: char;
    _next: CharNode;

  public
    property Value: char read _value write _value;
    property Next: CharNode read _next write _next;

    constructor Create(value: char; next: CharNode);
    begin
      _value := value;
      _next := next;
    end;

    constructor Create(value: char);
    begin
      Create(value, nil);
    end;
  end;
  
  StringNode = class
  private
    _value: string;
    _next: StringNode;

  public
    property Value: string read _value write _value;
    property Next: StringNode read _next write _next;

    constructor Create(value: string; next: StringNode);
    begin
      _value := value;
      _next := next;
    end;

    constructor Create(value: string);
    begin
      Create(value, nil);
    end;
  end;
  
  ObjectNode = class
  private
    _value: object;
    _next: ObjectNode;

  public
    property Value: object read _value write _value;
    property Next: ObjectNode read _next write _next;

    constructor Create(value: object; next: ObjectNode);
    begin
      _value := value;
      _next := next;
    end;

    constructor Create(value: object);
    begin
      Create(value, nil);
    end;
  end;
end.