//          .
unit Writer;
interface
  uses Types, Tuples, Containers;
  
  //     .
  function ObjectToString(a: object): string;

  //    .
  function ObjectToString(a: PComplex): string;
  
  //    .
  function ObjectToString(a: PIntNodeRec): string;
  
  //    .
  function ObjectToString(a: PRealNodeRec): string;
  
  //    .
  function ObjectToString(a: PCharNodeRec): string;


  //     .
  procedure Print(a: object);
  
  //          .
  procedure Println(a: object);
  
  //    .
  procedure Print(a: PComplex);

  //         .
  procedure Println(a: PComplex);
  
  //    .
  procedure Print(a: PIntNodeRec);

  //         .
  procedure Println(a: PIntNodeRec);
  
  //    .
  procedure Print(a: PRealNodeRec);

  //         .
  procedure Println(a: PRealNodeRec);
  
  //    .
  procedure Print(a: PCharNodeRec);

  //         .
  procedure Println(a: PCharNodeRec);
  
  
  //    .
  procedure Print(a: int);
  
  //         .
  procedure Println(a: int);

  //    .
  procedure Print(a: real);

  //         .
  procedure Println(a: real);

  //   .
  procedure Print(a: char);

  //        .
  procedure Println(a: char);

  //   .
  procedure Print(a: string);

  //        .
  procedure Println(a: string);

  //    .
  procedure Print(a: bool);

  //         .
  procedure Println(a: bool);

implementation
  const
    Delimiter = ', ';
    tupleBegin = '(';
    TupleEnd = ')';

  procedure Join(var s1: string; s2: string);
  begin
    s1 := s1 + s2;
  end;

  function ObjectToString(a: object): string;
  const
    ArrayBegin = '[';
    ArrayEnd = ']';

  var
    content: string;

    intT2: IntTuple2;
    realT2: RealTuple2;
    charT2: CharTuple2;
    stringT2: StringTuple2;
    objectT2: Tuple2;
    
    i: int;
    
    intA: IntArray;
    realA: RealArray;
    stringA: StringArray;
    objectA: ObjectArray;

  begin
    content := '';
    Result := '';

    if a = nil then
    begin
      Result := 'nil';
      exit;
    end;

    Join(Result, LowerCase(a.TypeName()));
    Join(Result, ': ');
    
    if a is IntNode then
      Join(Result, IntToStr(IntNode(a).Value))
    else if a is RealNode then
      Join(Result, FloatToStr(RealNode(a).Value))
    else if a is CharNode then
      Join(Result, CharNode(a).Value)
    else if a is CharNode then
      Join(Result, CharNode(a).Value)
    else if a is StringNode then
      Join(Result, StringNode(a).Value)
    else if a is IntTuple7 then // <<< Tuples
    begin
      intT2 := IntTuple2(a);
      Join(content, TupleBegin + IntToStr(intT2.Item1) + Delimiter + IntToStr(intT2.Item2) + Delimiter + IntToStr(IntTuple3(a).Item3) + Delimiter + IntToStr(IntTuple4(a).Item4) + Delimiter + IntToStr(IntTuple5(a).Item5) + Delimiter + IntToStr(IntTuple6(a).Item6) + Delimiter + IntToStr(IntTuple7(a).Item7) + TupleEnd)
    end
    else if a is IntTuple6 then
    begin
      intT2 := IntTuple2(a);
      Join(content, TupleBegin + IntToStr(intT2.Item1) + Delimiter + IntToStr(intT2.Item2) + Delimiter + IntToStr(IntTuple3(a).Item3) + Delimiter + IntToStr(IntTuple4(a).Item4) + Delimiter + IntToStr(IntTuple5(a).Item5) + Delimiter + IntToStr(IntTuple6(a).Item6) + TupleEnd)
    end
    else if a is IntTuple5 then
    begin
      intT2 := IntTuple2(a);
      Join(content, TupleBegin + IntToStr(intT2.Item1) + Delimiter + IntToStr(intT2.Item2) + Delimiter + IntToStr(IntTuple3(a).Item3) + Delimiter + IntToStr(IntTuple4(a).Item4) + Delimiter + IntToStr(IntTuple5(a).Item5) + TupleEnd)
    end
    else if a is IntTuple4 then
    begin
      intT2 := IntTuple2(a);
      Join(content, TupleBegin + IntToStr(intT2.Item1) + Delimiter + IntToStr(intT2.Item2) + Delimiter + IntToStr(IntTuple3(a).Item3) + Delimiter + IntToStr(IntTuple4(a).Item4) + TupleEnd)
    end
    else if a is IntTuple3 then
    begin
      intT2 := IntTuple2(a);
      Join(content, TupleBegin + IntToStr(intT2.Item1) + Delimiter + IntToStr(intT2.Item2) + Delimiter + IntToStr(IntTuple3(a).Item3) + TupleEnd)
    end
    else if a is IntTuple2 then
    begin
      intT2 := IntTuple2(a);
      Join(content, TupleBegin + IntToStr(intT2.Item1) + Delimiter + IntToStr(intT2.Item2) + TupleEnd)
    end
    else if a is RealTuple7 then // <<<
    begin
      realT2 := RealTuple2(a);
      Join(content, TupleBegin + FloatToStr(realT2.Item1) + Delimiter + FloatToStr(realT2.Item2) + Delimiter + FloatToStr(RealTuple3(a).Item3) + Delimiter + FloatToStr(RealTuple4(a).Item4) + Delimiter + FloatToStr(RealTuple5(a).Item5) + Delimiter + FloatToStr(RealTuple6(a).Item6) + Delimiter + FloatToStr(RealTuple7(a).Item7) + TupleEnd)
    end
    else if a is RealTuple6 then
    begin
      realT2 := RealTuple2(a);
      Join(content, TupleBegin + FloatToStr(realT2.Item1) + Delimiter + FloatToStr(realT2.Item2) + Delimiter + FloatToStr(RealTuple3(a).Item3) + Delimiter + FloatToStr(RealTuple4(a).Item4) + Delimiter + FloatToStr(RealTuple5(a).Item5) + Delimiter + FloatToStr(RealTuple6(a).Item6) + TupleEnd)
    end
    else if a is RealTuple5 then
    begin
      realT2 := RealTuple2(a);
      Join(content, TupleBegin + FloatToStr(realT2.Item1) + Delimiter + FloatToStr(realT2.Item2) + Delimiter + FloatToStr(RealTuple3(a).Item3) + Delimiter + FloatToStr(RealTuple4(a).Item4) + Delimiter + FloatToStr(RealTuple5(a).Item5) + TupleEnd)
    end
    else if a is RealTuple4 then
    begin
      realT2 := RealTuple2(a);
      Join(content, TupleBegin + FloatToStr(realT2.Item1) + Delimiter + FloatToStr(realT2.Item2) + Delimiter + FloatToStr(RealTuple3(a).Item3) + Delimiter + FloatToStr(RealTuple4(a).Item4) + TupleEnd)
    end
    else if a is RealTuple3 then
    begin
      realT2 := RealTuple2(a);
      Join(content, TupleBegin + FloatToStr(realT2.Item1) + Delimiter + FloatToStr(realT2.Item2) + Delimiter + FloatToStr(RealTuple3(a).Item3) + TupleEnd)
    end
    else if a is RealTuple2 then
    begin
      realT2 := RealTuple2(a);
      Join(content, TupleBegin + FloatToStr(RealT2.Item1) + Delimiter + FloatToStr(RealT2.Item2) + TupleEnd)
    end
    else if a is CharTuple7 then // <<<
    begin
      charT2 := CharTuple2(a);
      Join(content, TupleBegin + charT2.Item1 + Delimiter + charT2.Item2 + Delimiter + CharTuple3(a).Item3 + Delimiter + CharTuple4(a).Item4 + Delimiter + CharTuple5(a).Item5 + Delimiter + CharTuple6(a).Item6 + Delimiter + CharTuple7(a).Item7 + TupleEnd)
    end
    else if a is CharTuple6 then
    begin
      charT2 := CharTuple2(a);
      Join(content, TupleBegin + charT2.Item1 + Delimiter + charT2.Item2 + Delimiter + CharTuple3(a).Item3 + Delimiter + CharTuple4(a).Item4 + Delimiter + CharTuple5(a).Item5 + Delimiter + CharTuple6(a).Item6 + TupleEnd)
    end
    else if a is CharTuple5 then
    begin
      charT2 := CharTuple2(a);
      Join(content, TupleBegin + charT2.Item1 + Delimiter + charT2.Item2 + Delimiter + CharTuple3(a).Item3 + Delimiter + CharTuple4(a).Item4 + Delimiter + CharTuple5(a).Item5 + TupleEnd)
    end
    else if a is CharTuple4 then
    begin
      charT2 := CharTuple2(a);
      Join(content, TupleBegin + charT2.Item1 + Delimiter + charT2.Item2 + Delimiter + CharTuple3(a).Item3 + Delimiter + CharTuple4(a).Item4 + TupleEnd)
    end
    else if a is CharTuple3 then
    begin
      charT2 := CharTuple2(a);
      Join(content, TupleBegin + charT2.Item1 + Delimiter + charT2.Item2 + Delimiter + CharTuple3(a).Item3 + TupleEnd)
    end
    else if a is CharTuple2 then
    begin
      charT2 := CharTuple2(a);
      Join(content, TupleBegin + charT2.Item1 + Delimiter + charT2.Item2 + TupleEnd)
    end
    else if a is StringTuple7 then // <<<
    begin
      stringT2 := StringTuple2(a);
      Join(content, TupleBegin + stringT2.Item1 + Delimiter + stringT2.Item2 + Delimiter + StringTuple3(a).Item3 + Delimiter + StringTuple4(a).Item4 + Delimiter + StringTuple5(a).Item5 + Delimiter + StringTuple6(a).Item6 + Delimiter + StringTuple7(a).Item7 + TupleEnd)
    end
    else if a is StringTuple6 then
    begin
      stringT2 := StringTuple2(a);
      Join(content, TupleBegin + stringT2.Item1 + Delimiter + stringT2.Item2 + Delimiter + StringTuple3(a).Item3 + Delimiter + StringTuple4(a).Item4 + Delimiter + StringTuple5(a).Item5 + Delimiter + StringTuple6(a).Item6 + TupleEnd)
    end
    else if a is StringTuple5 then
    begin
      stringT2 := StringTuple2(a);
      Join(content, TupleBegin + stringT2.Item1 + Delimiter + stringT2.Item2 + Delimiter + StringTuple3(a).Item3 + Delimiter + StringTuple4(a).Item4 + Delimiter + StringTuple5(a).Item5 + TupleEnd)
    end
    else if a is StringTuple4 then
    begin
      stringT2 := StringTuple2(a);
      Join(content, TupleBegin + stringT2.Item1 + Delimiter + stringT2.Item2 + Delimiter + StringTuple3(a).Item3 + Delimiter + StringTuple4(a).Item4 + TupleEnd)
    end
    else if a is StringTuple3 then
    begin
      stringT2 := StringTuple2(a);
      Join(content, TupleBegin + stringT2.Item1 + Delimiter + stringT2.Item2 + Delimiter + StringTuple3(a).Item3 + TupleEnd)
    end
    else if a is StringTuple2 then
    begin
      stringT2 := StringTuple2(a);
      Join(content, TupleBegin + stringT2.Item1 + Delimiter + stringT2.Item2 + TupleEnd)
    end
    else if a is IntArray then // <<< Collections
    begin
      intA := IntArray(a);
      Join(content, ArrayBegin);
      for i := 1 to intA.Count do
      begin
        Join(content, IntToStr(intA[i]));
        if i < intA.Count then
          Join(content, Delimiter);
      end;
      Join(content, ArrayEnd);
    end
    else if a is RealArray then
    begin
      realA := RealArray(a);
      Join(content, ArrayBegin);
      for i := 1 to realA.Count do
      begin
        Join(content, FloatToStr(realA[i]));
        if i < realA.Count then
          Join(content, Delimiter);
      end;
      Join(content, ArrayEnd);
    end
    else if a is StringArray then
    begin
      stringA := StringArray(a);
      Join(content, ArrayBegin);
      for i := 1 to stringA.Count do
      begin
        Join(content, stringA[i]);
        if i < stringA.Count then
          Join(content, Delimiter);
      end;
      Join(content, ArrayEnd);
    end
    else if a is ObjectArray then
    begin
      objectA := ObjectArray(a);
      Join(content, ArrayBegin);
      for i := 1 to objectA.Count do
      begin
        Join(content, ObjectToString(objectA[i]));
        if i < objectA.Count then
          Join(content, Delimiter);
      end;
      Join(content, ArrayEnd);
    end
    else if a is Tuple7 then // <<< Object tuples
    begin
      objectT2 := Tuple2(a);
      Join(content, TupleBegin + ObjectToString(objectT2.Item1) + Delimiter + ObjectToString(objectT2.Item2) + Delimiter + ObjectToString(Tuple3(a).Item3) + Delimiter + ObjectToString(Tuple4(a).Item4) + Delimiter + ObjectToString(Tuple5(a).Item5) + Delimiter + ObjectToString(Tuple6(a).Item6) + Delimiter + ObjectToString(Tuple7(a).Item7) + TupleEnd)
    end
    else if a is Tuple6 then
    begin
      objectT2 := Tuple2(a);
      Join(content, TupleBegin + ObjectToString(objectT2.Item1) + Delimiter + ObjectToString(objectT2.Item2) + Delimiter + ObjectToString(Tuple3(a).Item3) + Delimiter + ObjectToString(Tuple4(a).Item4) + Delimiter + ObjectToString(Tuple5(a).Item5) + Delimiter + ObjectToString(Tuple6(a).Item6) + TupleEnd)
    end
    else if a is Tuple5 then
    begin
      objectT2 := Tuple2(a);
      Join(content, TupleBegin + ObjectToString(objectT2.Item1) + Delimiter + ObjectToString(objectT2.Item2) + Delimiter + ObjectToString(Tuple3(a).Item3) + Delimiter + ObjectToString(Tuple4(a).Item4) + Delimiter + ObjectToString(Tuple5(a).Item5) + TupleEnd)
    end
    else if a is Tuple4 then
    begin
      objectT2 := Tuple2(a);
      Join(content, TupleBegin + ObjectToString(objectT2.Item1) + Delimiter + ObjectToString(objectT2.Item2) + Delimiter + ObjectToString(Tuple3(a).Item3) + Delimiter + ObjectToString(Tuple4(a).Item4) + TupleEnd)
    end
    else if a is Tuple3 then
    begin
      objectT2 := Tuple2(a);
      Join(content, TupleBegin + ObjectToString(objectT2.Item1) + Delimiter + ObjectToString(objectT2.Item2) + Delimiter + ObjectToString(Tuple3(a).Item3) + TupleEnd)
    end
    else if a is Tuple2 then
    begin
      objectT2 := Tuple2(a);
      Join(content, TupleBegin + ObjectToString(objectT2.Item1) + Delimiter + ObjectToString(objectT2.Item2) + TupleEnd)
    end;
    Join(Result, content);
  end;
  
  function ObjectToString(a: PComplex): string;
  begin
    Result := 'complex:  ' + FloatToStr(a^.Re) + Delimiter + FloatToStr(a^.Im);
  end;
  
  function ObjectToString(a: PIntNodeRec): string;
  begin
    Result := 'IntNode' + Delimiter + IntToStr(a^.Value);
  end;
  
  function ObjectToString(a: PRealNodeRec): string;
  begin
    Result := 'RealNode' + Delimiter + FloatToStr(a^.Value);
  end;

  function ObjectToString(a: PCharNodeRec): string;
  begin
    Result := 'CharNode' + Delimiter + a^.Value;
  end;
  
  procedure Print(a: object);
  begin
    Write(ObjectToString(a));
  end;

  procedure Println(a: object);
  begin
    Print(a);
    Writeln();
  end;
  
  procedure Print(a: PComplex);
  begin
    Write(ObjectToString(a));
  end;

  procedure Println(a: PComplex);
  begin
    Print(a);
    Writeln();
  end;
  
  procedure Print(a: PIntNodeRec);
  begin
    Write(ObjectToString(a));
  end;

  procedure Println(a: PIntNodeRec);
  begin
    Print(a);
    Writeln();
  end;
  
  procedure Print(a: PRealNodeRec);
  begin
    Write(ObjectToString(a));
  end;

  procedure Println(a: PRealNodeRec);
  begin
    Print(a);
    Writeln();
  end;
  
  procedure Print(a: PCharNodeRec);
  begin
    Write(ObjectToString(a));
  end;

  procedure Println(a: PCharNodeRec);
  begin
    Print(a);
    Writeln();
  end;
  
  procedure Print(a: int);
  begin
    Write(a);
  end;

  procedure Println(a: int);
  begin
    Print(a);
    Writeln();
  end;
  
  procedure Print(a: real);
  begin
    Write(a);
  end;

  procedure Println(a: real);
  begin
    Print(a);
    Writeln();
  end;

  procedure Print(a: char);
  begin
    Write(a);
  end;

  procedure Println(a: char);
  begin
    Print(a);
    Writeln();
  end;
  
  procedure Print(a: string);
  begin
    Write(a);
  end;

  procedure Println(a: string);
  begin
    Print(a);
    Writeln();
  end;
  
  procedure Print(a: bool);
  begin
    Write(a);
  end;

  procedure Println(a: bool);
  begin
    Print(a);
    Writeln();
  end;
end.